﻿Imports Microsoft.Win32

Public Class frmFix
    Dim Version As String = "v0.5"
    Dim isATI As Boolean = False

    Private Structure strVideoDriver
        Dim ClassID As String
        Dim DeviceDescription As String

    End Structure

    Dim DriverList As New ArrayList

    Private Function NullToString(ByVal tempString As String) As String
        If String.IsNullOrEmpty(tempString) = True Then
            Return ""
        Else
            Return tempString
        End If
    End Function

    Private Function FixEmptyDeviceName(ByVal Driver As strVideoDriver) As strVideoDriver
        If Driver.DeviceDescription = "" Then
            Driver.DeviceDescription = Driver.ClassID
        End If
        Return Driver
    End Function

    Private Sub frmFix_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Text &= " " & Version

        ttpTool.SetToolTip(lblDevice, "Select your ATI graphic adapter, if it isn't detected automaticly.")
        ttpTool.SetToolTip(lblATIcard, "Indicates whether it is an ATI graphic adapter or not.")
        ttpTool.SetToolTip(lblRotation, "Indicates whether rotation is enabled or not.")
        ttpTool.SetToolTip(lblDirection, "Indicates whether the rotation is clockwise or counterclockwise.")

        Dim regKey As RegistryKey
        regKey = Registry.LocalMachine.OpenSubKey("System\CurrentControlSet\Control\Video", False)
        Dim tempDevice As strVideoDriver

        DriverList.Clear()
        cmbDevices.Items.Clear()
        For Each ClassID In regKey.GetSubKeyNames()
            Debug.Print(ClassID)
            tempDevice.ClassID = ClassID.ToString
            tempDevice.DeviceDescription = NullToString(regKey.OpenSubKey(ClassID).OpenSubKey("0000").GetValue("Device Description"))
            tempDevice = FixEmptyDeviceName(tempDevice)
            DriverList.Add(tempDevice)
            cmbDevices.Items.Add(tempDevice.DeviceDescription)
            If InStr(tempDevice.DeviceDescription, "ATI") <> 0 Then
                cmbDevices.SelectedIndex = cmbDevices.Items.Count - 1
            End If
        Next
        If cmbDevices.SelectedIndex = -1 Then
            MsgBox("You seem not to have installed an ATI graphic adapter, so this tool will be useless!")
        End If
        regKey.Close()
    End Sub

    Private Sub cmbDevices_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmbDevices.SelectedIndexChanged

        gpbShow.Text = cmbDevices.SelectedItem
        If InStr(cmbDevices.SelectedItem, "ATI") <> 0 Then
            txtATIcard.Text = "OK, this seems to be an ATI graphics adapter!"
            txtATIcard.ForeColor = Color.Green
            isATI = True
        Else
            txtATIcard.Text = "ERROR, this is no ATI graphics adapter!"
            txtATIcard.ForeColor = Color.Red
            isATI = False
        End If

        btnApply.Enabled = isATI
        lblRotation.Enabled = isATI
        txtRotation.Enabled = isATI
        txtRotation.Text = ""
        lblDirection.Enabled = False
        btnDirection.Enabled = False
        cmbDirection.Enabled = False

        If isATI = True Then
            Dim regKey As RegistryKey
            regKey = Registry.LocalMachine.OpenSubKey("System\CurrentControlSet\Control\Video\" & DriverList.Item(cmbDevices.SelectedIndex).ClassID & "\0000", False)
            Debug.Print(regKey.GetValue("DisableTabletPCRotation"))
            Debug.Print(regKey.GetValue("TabletPCRotateClockwise"))
            If regKey.GetValue("DisableTabletPCRotation") = 0 Then
                txtRotation.Text = "OK, rotation enabled"
                txtRotation.ForeColor = Color.Green
                lblDirection.Enabled = True
                btnDirection.Enabled = True
                cmbDirection.Enabled = True
            Else
                txtRotation.Text = "NO, rotation disabled"
                txtRotation.ForeColor = Color.Red
            End If
            If regKey.GetValue("TabletPCRotateClockwise") = 0 Then
                cmbDirection.SelectedIndex = 0
            Else
                cmbDirection.SelectedIndex = 1
            End If
        End If
    End Sub

    Private Sub btnApply_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnApply.Click
        Dim regKey As RegistryKey
        regKey = Registry.LocalMachine.OpenSubKey("System\CurrentControlSet\Control\Video\" & DriverList.Item(cmbDevices.SelectedIndex).ClassID & "\0000", True)
        Debug.Print(regKey.GetValue("DisableTabletPCRotation"))
        If regKey.GetValue("DisableTabletPCRotation") = 0 Then
            regKey.SetValue("DisableTabletPCRotation", 1)
        Else
            regKey.SetValue("DisableTabletPCRotation", 0)
        End If
        Call cmbDevices_SelectedIndexChanged(sender, e)
        MsgBox("Please restart your computer to take effects!", MsgBoxStyle.OkOnly, "Restart needed!")
    End Sub

    Private Sub btnDirection_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDirection.Click
        Dim regKey As RegistryKey
        regKey = Registry.LocalMachine.OpenSubKey("System\CurrentControlSet\Control\Video\" & DriverList.Item(cmbDevices.SelectedIndex).ClassID & "\0000", True)
        Debug.Print(regKey.GetValue("TabletPCRotateClockwise"))
        If cmbDirection.SelectedIndex = 0 Then
            regKey.SetValue("TabletPCRotateClockwise", 0)
        Else
            regKey.SetValue("TabletPCRotateClockwise", 1)
        End If
        Call cmbDevices_SelectedIndexChanged(sender, e)
        MsgBox("Please restart your computer to take effects!", MsgBoxStyle.OkOnly, "Restart needed!")
    End Sub

    Private Sub picDonate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picDonate.Click
        Process.Start("http://scilor.ac-host.net/donate.html")
    End Sub
End Class
